# Spencer Smith
# macid: smiths
# student number: #######
# February 27, 2011
#
# This is a solution for Major Assignment 3 (Lab 08).
def sumPartial(x, d):
    val = 0
    for i in range(0, d):
        val = val + x[i]
    for i in range(d+1, len(x)):
        val = val + x[i]
    return val

def extractCol(A, j):
    col = []
    for row in A:
        col.append(row[j])
    return col

def offDiagColSums(A):
    lst = []
    for j in range(len(A[0])):
        lst.append(sumPartial(extractCol(A, j), j))
    return lst
    
# Design Question
# 
#If sumPartial is implemented without a conditional statement and x[d]
#is first removed from the list, only one loop is required to sum the list.
#In the above solution, that loop is inside the built-in sum function.
#(If you used the built-in sum function, with no loops coded in sumPartial,
#an answer of 0 loops is also acceptable.).  You could also choose to not
#use the built-in sum function, and place the loop directly in your function:

#def sumPartial(x,d):
#    x_partial = x[:d] + x[d+1:]
#    sum_partial = 0
#    for i in x_partial:
#        sum_partial = sum_partial + i
#
#Alternatively, if x[d] is not is not removed from the list, two loops
#would be required:
#
#def sumPartial(x,d):
#    sum_partial = 0
#    for i in range(0,d):
#        x_partial = x_partial + i
#    for j in range(d+1,len(x)):
#        x_partial = x_partial + j
#    return x_partial
#      
# Test Plan
# 
#Test: 1 for function sumPartial
#Input:  x = [5, 2, 1], d = 1
#Expected Output: 6
#
#
#Test: 2 for function sumPartial
#Input:  x = [10, -2, 5, 3], d = -4
#Expected Output: 6
#Notice: The solution file computest the answer as 22, which is not the answer
#        we are expecting.
#
#
#Test: 1 for function extractCol
#Input:  A = [[3, 5, 6, 4],[1, 2, 3, 3], [9, 1, 6, 7]], j = 1
#Expected Output: [5,2,1]
#   
#
#Test: 2 for function extractCol
#Input:  A = [[3,5,6], [1,2,3], [9,1,6], [4,3,7]], j = 1
#Expected Output: [5,2,1,3]
#  
#
#Test: 1 for function offDiagColSums
#Input:  A = [[3,5,6,4], [1,2,3,3], [9,1,6,7]]
#Expected Output: [10, 6, 9, 14]
#
#
#Test: 2 for function offDiagColSums
#Input:  A = [[3,5,6], [1,2,3], [9,1,6], [4,3,7]]
#Expected Output:  [14, 9, 16]

