# Date: 2014-Apr-02  
from math import *

class ConvexPolygon:
    # create a new class which contains data--v(a list)
    def __init__(self,v):
        self.v = v
    # two accessors to get the length of v and the list of vertices from the object
    def getVertices(self):
        return self.v

    def getN(self):
        return len(self.v)
    
    # two mutators to change the data of the object
    def setVertex(self,i,x,y):
        self.v[i] = [x,y]

    def rotate(self,theta):
        # store the trig results into two variables
        a = cos(theta)
        b = sin(theta)
        #change each element in list(self.v)
        for ele in self.v:
            #store two original values into two variables
            x = ele[0]
            y = ele[1]
            #change the original values in the object
            ele[0] = a*x - b*y
            ele[1] = b*x + a*y
            
    # return a new object which is mutated from the original ConvexPolygon object
    def shift(self,x,y):
        a = x
        b = y
        Convexlist = []
        for ele in self.v:
            x0 = ele[0]
            y0 = ele[1]
            #add each mutated value into a new list to prepare the output
            Convexlist.append([(x0 + a),(y0 + b)])

        return ConvexPolygon(Convexlist)

##Design question:
##    1. In my program, firstly, I store the values of original x and y into
##    two new variables. Then I do the calculation. Therefore, no matter what the calculation
##    is, I can ensure that the original data will not be changed.
##
##Test Plan:
##Test on object ConvexPolygon([[0.0,0.0],[0.5,1.5],[2.5,1.5],[2.0,0.0]])
##
##    
##Test: i for getVertices()
##Input:None
##Expected Output: [[0.0, 0.0], [0.5, 1.5], [2.5, 1.5], [2.0, 0.0]]
##Actual Output:[[0.0, 0.0], [0.5, 1.5], [2.5, 1.5], [2.0, 0.0]]
##Pass
## 
##
##Test: i for getN()
##Input:None
##Expected Output:4
##Actual Output:4
##Pass
##
##
##Test: i for setVertex(i,x,y)
##Input:(2,0.6,0.7)
##Expected Output:[[0.0, 0.0], [0.5, 1.5], [0.6, 0.7], [2.0, 0.0]]
##Actual Output:[[0.0, 0.0], [0.5, 1.5], [0.6, 0.7], [2.0, 0.0]]
##Pass
##
##Test: ii for setVertex(i,x,y)
##Input:(4,1,1)
##Expected Output:Error
##Actual Output:IndexError
##Pass
##
##Test: i for rotate(theta)
##Input:(pi)
##Expected Output:[[-0.0, 0.0], [-0.5, -1.5], [-2.5, -1.5], [-2.0, 0]]
##Actual Output:[[-0.0, 0.0], [-0.5000000000000002, -1.5], [-2.5, -1.4999999999999998], [-2.0, 2.4492935982947064e-16]]
##Pass
##
##Test: ii for rotate(theta)
##Input:('s')
##Expected Output:Error
##Actual Output:TypeError
##Pass
##
##Test: i for shift(x,y)
##Input:(1,4)
##Expected Output:ConvexPolygon([[1.0, 4.0], [1.5, 5.5], [3.5, 5.5], [3.0, 4.0]])
##Actual Output:ConvexPolygon([[1.0, 4.0], [1.5, 5.5], [3.5, 5.5], [3.0, 4.0]])
##Pass
##
##Test: ii for shift(x,y)
##Input:('s',3)
##Expected Output:Error
##Actual Output:TypeError
##Pass


        

        
