# Ryan Martin
# macid: abcd123
# student number: #######
# February 23, 2012
#
#
# This is a solution for Major Assignment 5 (Lab 11) on Monday.

from math import sin, cos

class ConvexPolygon:

    def __init__(self, vertices):
        self.vertices = vertices

    def getVertices(self):
        #The [:] notation makes a copy, so we avoid aliasing issues
        return self.vertices[:]

    def getN(self):
        return len(self.vertices)

    def setVertex(self, i, x, y):
        self.vertices[i][0] = float(x)
        self.vertices[i][1] = float(y)

    def rotate(self, theta):
        for i in range(len(self.vertices)):
            vx = self.getVertices()[i][0]
            vy = self.getVertices()[i][1]
            self.vertices[i][0]=vx*cos(theta) - vy*sin(theta)
            self.vertices[i][1]=vx*sin(theta) + vy*cos(theta)

    def shift(self, x, y):
        result = []
        for i in range(len(self.vertices)):
            vx = self.getVertices()[i][0]
            vy = self.getVertices()[i][1]
            result.append([vx + x, vy + y])
        return ConvexPolygon(result)

'''
Design Question

When rotating x and y for each point, we must first store
both in temporary variables to ensure the correct calculation.

Alternatively, we can use multiple assignment in the setVertex
function to calculate both simultaneously, avoiding the need for
temporary variables altogether.
'''
##Note: This format is used by our automated marking system.
##You will see that, for inputs, the function name is
##given with the corresponding inputs to that function
##listed right after it. AutoMarker uses the data that you see here
##Format: [funName, [arg1, arg2, ...]]
##OR: 
##[ConvexPolygon, [initArg1, initArg2, ...], classFunName, [arg1, arg2, ...]]
##
##If you need to pass an instance of a class, use a tuple:
##('clsName', [arg1, arg2])
##and the class will be created at runtime.
##
##
##If the expected output for a function is an instance of a testingClass,
##each get method of testingClass and the actual output class will be compared.

'''
Testing Plan


class Class_State_Change: #equivalent to a basic ConvexPolygon class
	def __init__(self, v):
		self.v = v
	
	def getVertices(self):
		return self.v
       
v = [[0.75,3.5],[2.5,2.75],[2.25,-0.5],[-0.75,-1.5],[-0.25,2.25]]
v2 = [[]]

V05 = {'test1': 
       {'inputs': ['ConvexPolygon', [v], 'getN', []],
       'outputs': [5]},
	'test2': 
       {'inputs': ['ConvexPolygon', [v], 'setVertex', [1,2.0,3.0]],
       'outputs': [Class_State_Change([[0.75,3.5],[2.0,3.0],[2.25,-0.5],[-0.75,-1.5],[-0.25,2.25]])]},
       'test3':
       {'inputs': ['ConvexPolygon', [v], 'rotate', [3]],
       'outputs': [Class_State_Change([[-1.2364144006598694, -3.3591337320566588], [-2.8630612636657484, -2.369679345501557], [-2.1569231133210685, 0.8125162664349239], [0.9541743845401349, 1.379148738855768], [-0.07002189398458986, -2.2627631193659687]])]},
       'test4':
       {'inputs': ['ConvexPolygon', [v2], 'setVertex', [0,1.0,3.0]],
       'outputs': [IndexError: list assignment index out of range]},
       'test5':
       {'inputs': ['ConvexPolygon', [v], 'shift', [-1.5,2.5]],
       'outputs': [Class_State_Change([[-0.75, 6.0], [1.0, 5.25], [0.75, 2.0], [-2.25, 1.0], [-1.75, 4.75]])]}}

'''

